From 1b7e63b601675cc02b515d02cd34368b68dff137 Mon Sep 17 00:00:00 2001
From: skrzepto <shims506@gmail.com>
Date: Jun 21 2016 13:19:44 +0000
Subject: [PATCH 498/1001] Fixing model relation ship


---

1. when running delete-user.py with the hubs section commented out. When I enter user: `decause` to delete. From the db I see that the users table and associations table is affected and the hub is still around like predicted

2. This is with user already deleted. When I uncomment the hubs section from delete-user.py and enter user: `decause` to delete hub. The db hub row is gone and all its widgets are also all deleted.

3. With user still in db. From the db widgets, hubs. Association is missing the rows with decause in it but decause is still found in the users table just like we want

---

diff --git a/hubs/models.py b/hubs/models.py
index 32580a6..ee52937 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -107,8 +107,8 @@ class Association(BASE):
                         primary_key=True)
     role = sa.Column(sa.Enum(*roles), primary_key=True)
 
-    user = relation("User", backref=backref('associations', cascade="all, delete-orphan"))
-    hub = relation("Hub", backref=backref('associations', cascade="all, delete-orphan"))
+    user = relation("User", backref=backref('associations', cascade="all, delete"))
+    hub = relation("Hub", backref=backref('associations', cascade="all, delete"))
 
     @classmethod
     def get(cls, session, hub, user, role):
@@ -124,8 +124,7 @@ class Hub(BASE):
     name = sa.Column(sa.String(50), primary_key=True)
     summary = sa.Column(sa.String(128))
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
-    widgets = relation('Widget', cascade='all,delete-orphan', single_parent=True,
-                       backref=backref('hub', cascade='all'))
+    widgets = relation('Widget', cascade='all,delete', backref='hub')
     left_width = sa.Column(sa.Integer, nullable=False, default=8)
     archived = sa.Column(sa.Boolean, default=False)
     user_hub = sa.Column(sa.Boolean, default=False)

